<% Option Explicit %>

<head>
<link rel="stylesheet" href="ultrasound.css">
<title>Ultrasound FRS Reporting</title>
</head>

<body>
  
<%  

  const serverName = "YourSQLServerName"
  const dbName = "ultrasound"

  Application.Lock()

  function DBFieldToText(f)
    if isnull(f) then
        DBFieldToText = "-"
    else
        DBFieldToText = f
    end if        
  end function

  dim oConnection
  dim oRecordset
  dim queryCurrent
  dim queryHistory1
  dim queryHistory2
  dim queryHistory3
  dim propagationTime
  dim howLongAgo
  dim state
  dim rating
  dim color
  dim rowEven
  dim rgTimeSpans 
  dim timeSpan
  rgTimeSpans = Array(6, 24, 48, 60)

  Set oConnection = Server.CreateObject("ADODB.Connection")

  oConnection.Open "Provider=SQLOLEDB;Server=" & serverName & ";database=" & dbName & ";Integrated Security=SSPI;Persist Security Info=False;"
  
  queryCurrent = _
          "select RS.ReplicaSetFriendlyName, " & _
          "       datediff(minute, UL.StartTime, getutcdate()) as HowLongAgo, " & _
                  "RSD.NumMembers, RSD.NumFiles, " & _
                  "cast(cast(RSD.TotalFileSize as float) /(1024*1024) as decimal(20,2)) as TotalFileSize, " & _
                  "RSD.NumSharingViolations, RSD.NumFilesBacklogged, " & _
                  "cast(cast(RSD.TotalFileSizeBacklogged as float) /(1024*1024) as decimal(20,2)) as TotalFileSizeBacklogged " & _
          "from ReplicaSet RS " & _
                    "inner join ReplicaSetData RSD on RS.ReplicaSetID = RSD.ReplicaSetID " & _
                    "inner join UpdateList UL on RSD.UpdateID = UL.UpdateID " & _
          "where UL.EndTime >= '9999-01-01'  "  & _
          "order by RS.ReplicaSetFriendlyName" 

  queryHistory1 = _
        "select RS.ReplicaSetFriendlyName, "  & _
               "MetricSuccess.*,  "  & _
               "MetricFail.*  "  & _
        "from ReplicaSet RS "  & _
                "left join "  & _
                   "(select ReplicaSetID,  "  & _
                           "count(*) as NumPropagationTests, "  & _
                           "min(datediff(minute, PropagationTestStartTime, PropagationTestEndTime)) as MinPropagationTime, "  & _
                           "avg(datediff(minute, PropagationTestStartTime, PropagationTestEndTime)) as AvgPropagationTime, "  & _
                           "max(datediff(minute, PropagationTestStartTime, PropagationTestEndTime)) as MaxPropagationTime "  & _
                    "from PropagationTestData "  & _
                    "where JobState = 4 and "  & _
                          "PropagationTestEndTime < getutcdate() and "  & _
                          "PropagationTestEndTime >= dateadd(hour, -"
                          
  queryHistory2 = _
                        ", getutcdate()) "  & _
                    "group by ReplicaSetID "  & _
                    ") as MetricSuccess "  & _
                "on RS.ReplicaSetID = MetricSuccess.ReplicaSetID "  & _
                "left join "  & _
                "(select ReplicaSetID,  "  & _
                         "count(*) as NumPropagationTestsFailed "  & _
                    "from PropagationTestData "  & _
                    "where JobState <> 4 and "  & _
                          "PropagationTestEndTime < getutcdate() and "  & _
                          "PropagationTestEndTime >= dateadd(hour, -"
                          
  queryHistory3 = _
                          ", getutcdate()) "  & _
                    "group by ReplicaSetID "  & _
                ") as MetricFail "  & _
                "on RS.ReplicaSetID = MetricFail.ReplicaSetID " & _
                "order by AvgPropagationTime desc"
          
  set oRecordset = oConnection.Execute(queryCurrent)
%>

<b>Current data </b> (<%=Now()%>)

<br>
<br>

<table width="95%" CELLSPACING=0 align="center" class="withShadow">

  <tr style={background-color:#DEDEDE}>
    <td width="25%"><b>Replicaset</b></td>
    <td><b>Number of members</b></td>
    <td><b>Number of files</b></td>
    <td><b>Size (MB)</b></td>
    <td><b>Number of unique files in sharing violation</b></td>
    <td><b>Number of unique backlogged files</b></td>
    <td><b>Total size of unique backlogged files (MB)</b></td>
  </tr>
  
<%  
    rowEven = true
    
    Do while (Not oRecordset.eof) 
    
        howLongAgo = oRecordset("HowLongAgo")
        if isnull(howLongAgo) then
            howLongAgo = "n/a"
        end if  
      
        if rowEven then
            color = "white"
        else
            color = "#EEEEEE"
        end if  
        
        rowEven = not rowEven
        
%>
  <tr style={background-color:<% =color %>;}>
    <td> <% =oRecordset("ReplicaSetFriendlyName") %> &nbsp;(<% =howLongAgo %> minutes ago) </td>
    <td> <% =oRecordset("NumMembers") %> </td>
    <td> <% =oRecordset("NumFiles") %> </td>
    <td> <% =oRecordset("TotalFileSize") %> </td>
    <td> <% =oRecordset("NumSharingViolations") %> </td>
    <td> <% =oRecordset("NumFilesBacklogged") %> </td>
    <td> <% =oRecordset("TotalFileSizeBacklogged") %> </td>
  </tr>
<%  
    oRecordset.MoveNext 
  Loop 
  
  oRecordset.Close
%>

</table>

<br>
<br>

<% for each timeSpan in rgTimeSpans %>
    
<b>Propagation tests statistics for last <% =timeSpan %>  hours</b>

<br>
<br>

<table width="95%" CELLSPACING=0 align="center" class="withShadow">

  <tr style={background-color:#DEDEDE}>
    <td width="25%"><b>Replicaset</b></td>
    <td><b>Number of propagation tests succeeded</b></td>
    <td><b>Min propagation time (min)</b></td>
    <td><b>Avg propagation time (min)</b></td>
    <td><b>Max propagation time (min)</b></td>
    <td><b>Number of propagation tests failed</b></td>
  </tr>
  

  
<%  
    set oRecordset = oConnection.Execute(queryHistory1 & timeSpan & queryHistory2 & timeSpan & queryHistory3)
    
    rowEven = true
    
    Do while (Not oRecordset.eof) 
        
        if rowEven then
            color = "white"
        else
            color = "#EEEEEE"
        end if  
        
        rowEven = not rowEven
%>
  <tr style={background-color:<% =color %>;}>
    <td> <% =oRecordset("ReplicaSetFriendlyName") %> </td>
    <td> <% =DBFieldToText(oRecordset("NumPropagationTests")) %> </td>
    <td> <% =DBFieldToText(oRecordset("MinPropagationTime")) %> </td>
    <td> <% =DBFieldToText(oRecordset("AvgPropagationTime")) %> </td>
    <td> <% =DBFieldToText(oRecordset("MaxPropagationTime")) %> </td>
    <td> <% =DBFieldToText(oRecordset("NumPropagationTestsFailed")) %> </td>
  </tr>
<%  
    oRecordset.MoveNext 
  Loop 
  
  oRecordset.Close
%>

</table>

<br>
<br>

<% next %>

<%  
  oConnection.Close

  Application.Unlock
%>

</body>