<% Option Explicit %>

<head>

<link rel="stylesheet" href="ultrasound.css">

<title>Ultrasound FRS Reporting</title>

</head>
<body>
  
<%  

  const serverName = "YourSQLServerName"
  const dbName = "ultrasound"

  Application.Lock()

  dim oConnection
  dim oRecordset
  dim query
  dim propagationTime
  dim howLongAgo
  dim state
  dim rating
  dim color
  dim rowEven
  dim health

  Set oConnection = Server.CreateObject("ADODB.Connection")

  oConnection.Open "Provider=SQLOLEDB;Server=" & serverName & ";database=" & dbName & ";Integrated Security=SSPI;Persist Security Info=False;"
  
  query = "select RS.ReplicaSetFriendlyName, " & _
               "PTD.JobState, " & _
               "datediff(hour, PTD.PropagationTestEndTime, getutcdate()) as HowLongAgo, " & _
               "datediff(hour, PTD.PropagationTestStartTime, PTD.PropagationTestEndTime) as PropagationTime, " & _
               "case " & _
                 "when datediff(hour, PTD.PropagationTestStartTime, PTD.PropagationTestEndTime) <= 3 then 0 " & _
                 "when datediff(hour, PTD.PropagationTestStartTime, PTD.PropagationTestEndTime) <= 24 then 1 " & _
                 "when datediff(hour, PTD.PropagationTestStartTime, PTD.PropagationTestEndTime) > 24 then 2 " & _
                 "else null " & _
               "end as Rating " & _
          "from ReplicaSet RS " & _
                    "left join " & _
                    "( " & _
                    "   select ReplicaSetID, max(PropagationTestDataID) as PropagationTestDataID " & _
                    "   from PropagationTestData " & _
                    "   where PropagationTestEndTime < getutcdate() " & _
                    "   group by ReplicaSetID " & _
                    ") LastPropagationTest on RS.ReplicaSetID = LastPropagationTest.ReplicaSetID " & _
                    "left join PropagationTestData PTD on LastPropagationTest.PropagationTestDataID = PTD.PropagationTestDataID " & _
                    "order by Rating desc, PropagationTime desc "

  set oRecordset = oConnection.Execute(query)
%>

<table width="95%" CELLSPACING=0 align="center" class="withShadow">

  <tr style={background-color:#DEDEDE}>
    <td><b>Replicaset</b></td>
    <td><b>Health</b></td>
    <td><b>Latest propagation test status</b></td>
    <td><b>Latest propagation time (hours)</b></td>
  </tr>

<% 
    rowEven = false
    Do while (Not oRecordset.eof) 

      rating = oRecordset("Rating")
      if isnull(rating) then
         health = "n/a"
      elseif rating = 1 then
         health = "<img src='HealthYellow.gif' width=16 height=16>"
      elseif rating = 2 then
         health = "<img src='HealthRed.gif' width=16 height=16>"
      else
         health = "<img src='HealthGreen.gif' width=16 height=16>"
      end if
        
      if rowEven then
        color = "#EEEEEE"
      else
        color = "white"
      end if  
      rowEven = not rowEven
      
      propagationTime = oRecordset("PropagationTime")
      if isnull(propagationTime) then
         propagationTime = "n/a"
      end if  
      
      howLongAgo = oRecordset("HowLongAgo")
      if isnull(howLongAgo) then
         howLongAgo = "n/a"
      end if  
      
      state = oRecordset("JobState")
      if isnull(state) then
         state = "n/a"
      elseif state = 4 then 
         state = "succeeded" 
      else            
         state = "failed" 
         health = "<img src='HealthRed.gif' width=16 height=16>"
      end if  
      
%>
  <tr style={background-color:<% =color %>;}>
    <td> <% =oRecordset("ReplicaSetFriendlyName") %> &nbsp;&nbsp; (<% =howLongAgo %> hours ago) </td>
    <td> <% =health %> </td>
    <td> <% =state %> </td>
    <td> <% =propagationTime %> </td>
  </tr>
<%  
    oRecordset.MoveNext 
  Loop 
%>

</table>

<%  
  oConnection.Close

  Application.Unlock
%>

</body>