<% Option Explicit %>

<head>
<link rel="stylesheet" href="ultrasound.css">
</head>

<body>
  
<%  

  const serverName = "YourSQLServerName"
  const dbName = "ultrasound"

  Application.Lock()

  function GetHealthHTML(rating)
    if isnull(rating) then
       GetHealthHTML = "n/a"
    elseif rating = 1 then
       GetHealthHTML = "<img src='HealthYellow.gif' width=16 height=16>"
    elseif rating = 2 then
       GetHealthHTML = "<img src='HealthRed.gif' width=16 height=16>"
    else
       GetHealthHTML = "<img src='HealthGreen.gif' width=16 height=16>"
    end if
  end function

  dim oConnection
  dim oRecordset
  dim queryReplicas
  dim queryMembers
  dim queryConnections
  dim propagationTime
  dim howLongAgo
  dim state
  dim rating
  dim color
  dim health
  dim rowEven
  dim howLong

  Set oConnection = Server.CreateObject("ADODB.Connection")

  oConnection.Open "Provider=SQLOLEDB;Server=" & serverName & ";database=" & dbName & ";Integrated Security=SSPI;Persist Security Info=False;"
  
  queryReplicas = _
          "select RS.ReplicaSetFriendlyName, " & _
                 "coalesce(HR.Rating, 0) as Rating, " & _
                 "case " & _
                    "when HR.Rating is null then datediff(hour, LastHealthUpdates.EndTime, getutcdate())  " & _
                    "else datediff(hour, StartOfLastHealthBlock.StartTime, getutcdate()) " & _
                 "end as HowLong, " & _
                 "dbo.GetNumMembersWithHealth(RS.ReplicaSetID, 1, getUTCDate()) as NumYellowMembers,  " & _
                 "dbo.GetNumMembersWithHealth(RS.ReplicaSetID, 2, getUTCDate()) as NumRedMembers,  " & _
                 "dbo.GetNumReplicaSetInboundConnectionsWithHealth(RS.ReplicaSetID, 1, getUTCDate()) as NumYellowInboundConnections,  " & _
                 "dbo.GetNumReplicaSetOutboundConnectionsWithHealth(RS.ReplicaSetID, 1, getUTCDate()) as NumYellowOutboundConnections,  " & _
                 "dbo.GetNumReplicaSetInboundConnectionsWithHealth(RS.ReplicaSetID, 2, getUTCDate()) as NumRedInboundConnections,  " & _
                 "dbo.GetNumReplicaSetOutboundConnectionsWithHealth(RS.ReplicaSetID, 2, getUTCDate()) as NumRedOutboundConnections " & _
          "from ReplicaSet RS " & _
                  "left join HealthRating HR on HR.ObjectType = 1 and  " & _
                                               "HR.ObjectID = RS.ReplicaSetID and   " & _
                                               "HR.Rating <> 0 and " & _
                                               "HR.EndTime > getutcdate() " & _
                  "left join " & _
                    "( " & _
                        "select HR.ObjectID, max(HR.StartTime) as StartTime " & _
                        "from HealthRating HR " & _
                                "left join HealthRating HRPrev on HR.ObjectType = HRPrev.ObjectType and " & _
                                                                 "HR.ObjectID = HRPrev.ObjectID and " & _
                                                                 "HR.StartTime = HRPrev.EndTime and " & _
                                                                 "HR.Rating = HRPrev.Rating and " & _
                                                                 "HR.HealthRatingID > HRPrev.HealthRatingID " & _
                        "where HRPrev.Rating is null and  " & _
                              "HR.ObjectType = 1 " & _
                        "group by HR.ObjectType, HR.ObjectID " & _
                    ") as StartOfLastHealthBlock on StartOfLastHealthBlock.ObjectID = RS.ReplicaSetID " & _
                  "left join  " & _
                    "( " & _
                        "select ObjectID, max(EndTime) as EndTime " & _
                        "from HealthRating  " & _
                        "where ObjectType = 1 and " & _
                              "EndTime < getUTCDate() " & _
                        "group by ObjectID  " & _
                    ") as LastHealthUpdates on LastHealthUpdates.ObjectID = RS.ReplicaSetID " & _
            "order by HR.Rating desc, ReplicaSetFriendlyName asc "
            

  queryMembers = _
        "select  " & _
            "S.ServerName, " & _
            "RS.ReplicaSetFriendlyName, " & _
            "HR.Rating,  " & _
            "datediff(hour, StartOfLastHealthBlock.StartTime, getutcdate()) as HowLong, " & _
            "coalesce(OCYellow.NumConnections, 0) as NumYellowOutboundConnections, " & _
            "coalesce(ICYellow.NumConnections, 0) as NumYellowInboundConnections, " & _
            "coalesce(OCRed.NumConnections, 0) as NumRedOutboundConnections, " & _
            "coalesce(ICRed.NumConnections, 0) as NumRedInboundConnections " & _
        "from Member M " & _
                "inner join HealthRating HR on HR.ObjectType = 3 and " & _
                                              "HR.ObjectID = M.MemberID and   " & _
                                              "HR.Rating <> 0 and " & _
                                              "HR.EndTime > getutcdate() " & _
                "inner join Server S on M.ServerID = S.ServerID " & _
                "inner join ReplicaSet RS on M.ReplicaSetID = RS.ReplicaSetID " & _
                "inner join " & _
                "( " & _
                    "select HR.ObjectID, max(HR.StartTime) as StartTime " & _
                    "from HealthRating HR " & _
                            "left join HealthRating HRPrev on HR.ObjectType = HRPrev.ObjectType and " & _
                                                             "HR.ObjectID = HRPrev.ObjectID and " & _
                                                             "HR.StartTime = HRPrev.EndTime and " & _
                                                             "HR.Rating = HRPrev.Rating and " & _
                                                             "HR.HealthRatingID > HRPrev.HealthRatingID " & _
                    "where HRPrev.Rating is null and  " & _
                          "HR.ObjectType = 3 " & _
                    "group by HR.ObjectType, HR.ObjectID " & _
                ") as StartOfLastHealthBlock on StartOfLastHealthBlock.ObjectID = M.MemberID  " & _
                "left join dbo.GetCurrentMembersOCNumWithHealth(2) OCRed on M.MemberID = OCRed.MemberID " & _ 
                "left join dbo.GetCurrentMembersICNumWithHealth(2) ICRed on M.MemberID = ICRed.MemberID " & _
                "left join dbo.GetCurrentMembersOCNumWithHealth(1) OCYellow on M.MemberID = OCYellow.MemberID " & _
                "left join dbo.GetCurrentMembersICNumWithHealth(1) ICYellow on M.MemberID = ICYellow.MemberID " & _
        "order by HR.Rating desc, ServerName asc, ReplicaSetFriendlyName asc"


  queryConnections = _
        "select C.ConnectionFriendlyName,  " & _
               "UnhealthyConnections.Rating,  " & _
               "datediff(hour, UnhealthyConnections.StartTime, getutcdate()) as HowLong, " & _
               "RS.ReplicaSetFriendlyName, " & _
               "UnhealthyConnections.Direction " & _
        "from  " & _
            "( " & _
                "select IC.GlobalConnectionID, " & _
                	   "IC.ReplicaSetID, " & _
                       "HR.Rating, " & _
                       "StartOfLastHealthBlock.StartTime, " & _
                       "'inbound' as Direction " & _
                "from InboundConnection IC " & _
                    	"inner join HealthRating HR on HR.ObjectID = IC.InboundConnectionID and " & _
                	                                  "HR.ObjectType = 4 and " & _
                                                      "getutcdate() < HR.EndTime " & _
                        "inner join " & _
                        "( " & _
                            "select HR.ObjectID, max(HR.StartTime) as StartTime " & _
                            "from HealthRating HR " & _
                                    "left join HealthRating HRPrev on HR.ObjectType = HRPrev.ObjectType and " & _
                                                                     "HR.ObjectID = HRPrev.ObjectID and " & _
                                                                     "HR.StartTime = HRPrev.EndTime and " & _
                                                                     "HR.Rating = HRPrev.Rating and " & _
                                                                     "HR.HealthRatingID > HRPrev.HealthRatingID " & _
                            "where HRPrev.Rating is null and  " & _
                                  "HR.ObjectType = 4 " & _
                            "group by HR.ObjectType, HR.ObjectID " & _
                        ") as StartOfLastHealthBlock on StartOfLastHealthBlock.ObjectID = IC.InboundConnectionID " & _
                "union all " & _
                "select OC.GlobalConnectionID, " & _
                	   "OC.ReplicaSetID, " & _
                       "HR.Rating, " & _
                       "StartOfLastHealthBlock.StartTime, " & _
                       "'outbound' as Direction " & _
                "from OutboundConnection OC " & _
                        "inner join HealthRating HR on HR.ObjectID = OC.OutboundConnectionID and " & _
                	                                  "HR.ObjectType = 5 and " & _
                                                      "getutcdate() < HR.EndTime " & _
                        "inner join " & _
                        "( " & _
                            "select HR.ObjectID, max(HR.StartTime) as StartTime " & _
                            "from HealthRating HR " & _
                                    "left join HealthRating HRPrev on HR.ObjectType = HRPrev.ObjectType and " & _
                                                                     "HR.ObjectID = HRPrev.ObjectID and " & _
                                                                     "HR.StartTime = HRPrev.EndTime and " & _
                                                                     "HR.Rating = HRPrev.Rating and " & _
                                                                     "HR.HealthRatingID > HRPrev.HealthRatingID " & _
                            "where HRPrev.Rating is null and  " & _
                                  "HR.ObjectType = 5 " & _
                            "group by HR.ObjectType, HR.ObjectID " & _
                        ") as StartOfLastHealthBlock on StartOfLastHealthBlock.ObjectID = OC.OutboundConnectionID  " & _
            ") as UnhealthyConnections " & _
            "inner join ReplicaSet RS on UnhealthyConnections.ReplicaSetID = RS.ReplicaSetID " & _
        	"left join Connection C on UnhealthyConnections.GlobalConnectionID = C.GlobalConnectionID " & _
        "order by Rating desc, ConnectionFriendlyName asc "
        
  set oRecordset = oConnection.Execute(queryReplicas)
%>

<br>

<b>Replicasets</b>

<br>
<br>

<table width="95%" CELLSPACING=0 align="center" class="withShadow">

  <tr style={background-color:#DEDEDE}>
    <td width="25%"><b>Replicaset</b></td>
    <td><b>Health</b></td>
    <td><b>Number of red members</b></td>
    <td><b>Number of yellow members</b></td>
    <td><b>Number of red inbound connections</b></td>
    <td><b>Number of red outbound connections</b></td>
    <td><b>Number of yellow inbound connections</b></td>
    <td><b>Number of yellow outbound connections</b></td>
  </tr>
  
<%  
    rowEven = false
    Do while (Not oRecordset.eof) 
       
        howLong = oRecordset("HowLong")
        if isnull(howLong) then
            howLong = "n/a"
        end if
         
        rating = oRecordset("Rating")
        health = GetHealthHTML(rating)
        
        if rowEven then
            color = "#EEEEEE"
        else
            color = "white"
        end if  
        
        rowEven = not rowEven
        
%>
  <tr style={background-color:<% =color %>;}>
    <td> <% =oRecordset("ReplicaSetFriendlyName") %> &nbsp;(for <% =howLong %> hours) </td>
    <td> <% =health %> </td>
    <td> <% =oRecordset("NumRedMembers") %> </td>
    <td> <% =oRecordset("NumYellowMembers") %> </td>
    <td> <% =oRecordset("NumRedInboundConnections") %> </td>
    <td> <% =oRecordset("NumRedOutboundConnections") %> </td>
    <td> <% =oRecordset("NumYellowInboundConnections") %> </td>
    <td> <% =oRecordset("NumYellowOutboundConnections") %> </td>
  </tr>

<%  
    oRecordset.MoveNext 
  Loop 
  
  oRecordset.Close
%>

</table>

<br>
<br>

<b>Unhealthy members</b>

<br>
<br>

<table width="95%" CELLSPACING=0 align="center" class="withShadow">

  <tr style={background-color:#DEDEDE}>
    <td width="25%"><b>Server</b></td>
    <td width="25%"><b>Replicaset</b></td>
    <td><b>Health</b></td>
    <td><b>Number of red inbound connections</b></td>
    <td><b>Number of red outbound connections</b></td>
    <td><b>Number of yellow inbound connections</b></td>
    <td><b>Number of yellow outbound connections</b></td>
  </tr>

<%  
    set oRecordset = oConnection.Execute(queryMembers)
    
    Do while (Not oRecordset.eof) 
        
        rating = oRecordset("Rating")
        health = GetHealthHTML(rating)
        
        if rowEven then
            color = "#EEEEEE"
        else
            color = "white"
        end if  
        rowEven = not rowEven
%>
  <tr style={background-color:<% =color %>;}>
    <td> <% =oRecordset("ServerName") %> &nbsp;(for <% =oRecordset("HowLong") %> hours) </td>
    <td> <% =oRecordset("ReplicaSetFriendlyName") %> </td>
    <td> <% =health %> </td>
    <td> <% =oRecordset("NumRedInboundConnections") %> </td>
    <td> <% =oRecordset("NumRedOutboundConnections") %> </td>
    <td> <% =oRecordset("NumYellowInboundConnections") %> </td>
    <td> <% =oRecordset("NumYellowOutboundConnections") %> </td>
  </tr>

<%  
    oRecordset.MoveNext 
  Loop 
  
  oRecordset.Close
%>

</table>


<br>
<br>

<b>Unhealthy connections</b>

<br>
<br>

<table width="95%" CELLSPACING=0 align="center" class="withShadow">

  <tr style={background-color:#DEDEDE}>
    <td width="33%"><b>Connection</b></td>
    <td width="33%"><b>Replicaset</b></td>
    <td><b>Health</b></td>
    <td><b>Direction</b></td>
  </tr>

<%  
    set oRecordset = oConnection.Execute(queryConnections)
    
    Do while (Not oRecordset.eof) 
        
        rating = oRecordset("Rating")
        health = GetHealthHTML(rating)
        
        if rowEven then
            color = "#EEEEEE"
        else
            color = "white"
        end if  
        rowEven = not rowEven
%>
  <tr style={background-color:<% =color %>;}>
    <td> <% =oRecordset("ConnectionFriendlyName") %> &nbsp;(for <% =oRecordset("HowLong") %> hours) </td>
    <td> <% =oRecordset("ReplicaSetFriendlyName") %> </td>
    <td> <% =health %> </td>
    <td> <% =oRecordset("Direction") %> </td>
  </tr>

<%  
    oRecordset.MoveNext 
  Loop 
  
  oRecordset.Close
%>

</table>

<%  
  oConnection.Close

  Application.Unlock
%>

</body>